
_interrupt:

;MIDImon.c,59 :: 		void interrupt() {                                                              // Interrupt routine
;MIDImon.c,60 :: 		if(RC2IF_bit == 1) {                                                        // Checks for Receive Interrupt Flag bit
	BTFSS       RC2IF_bit+0, BitPos(RC2IF_bit+0) 
	GOTO        L_interrupt0
;MIDImon.c,61 :: 		u2_rx_data = UART2_Read();                                              // Storing read data
	CALL        _UART2_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _u2_rx_data+0 
;MIDImon.c,62 :: 		ByteToHex(u2_rx_data, int_rx_buf);
	MOVF        R0, 0 
	MOVWF       FARG_ByteToHex_input+0 
	MOVLW       _int_rx_buf+0
	MOVWF       FARG_ByteToHex_output+0 
	MOVLW       hi_addr(_int_rx_buf+0)
	MOVWF       FARG_ByteToHex_output+1 
	CALL        _ByteToHex+0, 0
;MIDImon.c,63 :: 		u2_rx_flag = 1;
	MOVLW       1
	MOVWF       _u2_rx_flag+0 
;MIDImon.c,64 :: 		}
L_interrupt0:
;MIDImon.c,65 :: 		}
L_end_interrupt:
L__interrupt113:
	RETFIE      1
; end of _interrupt

_main:

;MIDImon.c,67 :: 		void main() {
;MIDImon.c,68 :: 		rxidx  = 0;                                                                 // Initialisation of variable
	CLRF        _rxidx+0 
;MIDImon.c,69 :: 		ANSELB = 0;                                                                 // Configure PORT pins as digital
	CLRF        ANSELB+0 
;MIDImon.c,70 :: 		ANSELC = 0;                                                                 // Configure PORT pins as digital
	CLRF        ANSELC+0 
;MIDImon.c,71 :: 		ANSELD = 0;                                                                 // Configure PORT pins as digital
	CLRF        ANSELD+0 
;MIDImon.c,72 :: 		TRISB  = 0;                                                                 // Configure PORT as output
	CLRF        TRISB+0 
;MIDImon.c,73 :: 		TRISC  = 0;                                                                 // Configure PORT as output
	CLRF        TRISC+0 
;MIDImon.c,74 :: 		TRISD  = 0;                                                                 // Configure PORT as output
	CLRF        TRISD+0 
;MIDImon.c,75 :: 		LATB = 0x00;                                                                // clear all pin to Low
	CLRF        LATB+0 
;MIDImon.c,76 :: 		LATC = 0x00;                                                                // clear all pin to Low
	CLRF        LATC+0 
;MIDImon.c,77 :: 		LATD = 0x00;                                                                // clear all pin to Low
	CLRF        LATD+0 
;MIDImon.c,78 :: 		UART1_Init(115200);                                                         // Initialize UART 1 module at least 3x MIDI rate
	BSF         BAUDCON+0, 3, 0
	CLRF        SPBRGH+0 
	MOVLW       68
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;MIDImon.c,79 :: 		UART2_Init(31250);                                                          // Initialize UART 2 module for midi
	BSF         BAUDCON2+0, 3, 0
	CLRF        SPBRGH2+0 
	MOVLW       255
	MOVWF       SPBRG2+0 
	BSF         TXSTA2+0, 2, 0
	CALL        _UART2_Init+0, 0
;MIDImon.c,80 :: 		Delay_ms(100);                                                              // Wait for UART modules to stabilize
	MOVLW       5
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L_main1:
	DECFSZ      R13, 1, 1
	BRA         L_main1
	DECFSZ      R12, 1, 1
	BRA         L_main1
	DECFSZ      R11, 1, 1
	BRA         L_main1
;MIDImon.c,81 :: 		newcmd = '?';                                                               // default to help
	MOVLW       63
	MOVWF       _newcmd+0 
;MIDImon.c,82 :: 		cmd = newcmd;
	MOVLW       63
	MOVWF       _cmd+0 
;MIDImon.c,84 :: 		UART1_Write_Line("\r\nMIDI Monitor 29 Aug 2019");                               // introduction text
	MOVLW       ?lstr1_MIDImon+0
	MOVWF       FARG_UART1_Write_Line_uart_text+0 
	MOVLW       hi_addr(?lstr1_MIDImon+0)
	MOVWF       FARG_UART1_Write_Line_uart_text+1 
	CALL        _UART1_Write_Line+0, 0
;MIDImon.c,85 :: 		UART1_Write_Line("? for help");                                             // introduction text
	MOVLW       ?lstr2_MIDImon+0
	MOVWF       FARG_UART1_Write_Line_uart_text+0 
	MOVLW       hi_addr(?lstr2_MIDImon+0)
	MOVWF       FARG_UART1_Write_Line_uart_text+1 
	CALL        _UART1_Write_Line+0, 0
;MIDImon.c,87 :: 		RC2IE_bit = 1;                                                              // turn ON interrupt on UART1 receive
	BSF         RC2IE_bit+0, BitPos(RC2IE_bit+0) 
;MIDImon.c,88 :: 		RC2IF_bit = 0;                                                              // Clear interrupt flag
	BCF         RC2IF_bit+0, BitPos(RC2IF_bit+0) 
;MIDImon.c,89 :: 		PEIE_bit  = 1;                                                              // Enable peripheral interrupts
	BSF         PEIE_bit+0, BitPos(PEIE_bit+0) 
;MIDImon.c,90 :: 		GIE_bit   = 1;                                                              // Enable GLOBAL interrupts
	BSF         GIE_bit+0, BitPos(GIE_bit+0) 
;MIDImon.c,92 :: 		while(1){
L_main2:
;MIDImon.c,93 :: 		linein(linebuff);
	MOVLW       _linebuff+0
	MOVWF       FARG_linein_pstring+0 
	MOVLW       hi_addr(_linebuff+0)
	MOVWF       FARG_linein_pstring+1 
	CALL        _linein+0, 0
;MIDImon.c,94 :: 		newcmd = getparams(linebuff);
	MOVLW       _linebuff+0
	MOVWF       FARG_getparams_tempstring+0 
	MOVLW       hi_addr(_linebuff+0)
	MOVWF       FARG_getparams_tempstring+1 
	CALL        _getparams+0, 0
	MOVF        R0, 0 
	MOVWF       _newcmd+0 
;MIDImon.c,95 :: 		switch(newcmd){
	GOTO        L_main4
;MIDImon.c,96 :: 		case 'B':
L_main6:
;MIDImon.c,97 :: 		cmdb();
	CALL        _cmdb+0, 0
;MIDImon.c,98 :: 		break;
	GOTO        L_main5
;MIDImon.c,100 :: 		case 'C':
L_main7:
;MIDImon.c,101 :: 		cmdc();
	CALL        _cmdc+0, 0
;MIDImon.c,102 :: 		break;
	GOTO        L_main5
;MIDImon.c,104 :: 		case 'D':
L_main8:
;MIDImon.c,105 :: 		cmdd();
	CALL        _cmdd+0, 0
;MIDImon.c,106 :: 		break;
	GOTO        L_main5
;MIDImon.c,108 :: 		case 'I':
L_main9:
;MIDImon.c,109 :: 		cmdi();
	CALL        _cmdi+0, 0
;MIDImon.c,110 :: 		break;
	GOTO        L_main5
;MIDImon.c,112 :: 		case 'L':
L_main10:
;MIDImon.c,113 :: 		cmdl();
	CALL        _cmdl+0, 0
;MIDImon.c,114 :: 		break;
	GOTO        L_main5
;MIDImon.c,116 :: 		case 'O':
L_main11:
;MIDImon.c,117 :: 		cmdo();
	CALL        _cmdo+0, 0
;MIDImon.c,118 :: 		break;
	GOTO        L_main5
;MIDImon.c,120 :: 		case 'P':
L_main12:
;MIDImon.c,121 :: 		cmdp();
	CALL        _cmdp+0, 0
;MIDImon.c,122 :: 		break;
	GOTO        L_main5
;MIDImon.c,124 :: 		case 'Z':
L_main13:
;MIDImon.c,125 :: 		cmdz();
	CALL        _cmdz+0, 0
;MIDImon.c,126 :: 		break;
	GOTO        L_main5
;MIDImon.c,128 :: 		case '?':
L_main14:
;MIDImon.c,129 :: 		UART1_Write_Line("?        List Commands");
	MOVLW       ?lstr3_MIDImon+0
	MOVWF       FARG_UART1_Write_Line_uart_text+0 
	MOVLW       hi_addr(?lstr3_MIDImon+0)
	MOVWF       FARG_UART1_Write_Line_uart_text+1 
	CALL        _UART1_Write_Line+0, 0
;MIDImon.c,130 :: 		UART1_Write_Line("b nn     Output hex nn to PORT B");
	MOVLW       ?lstr4_MIDImon+0
	MOVWF       FARG_UART1_Write_Line_uart_text+0 
	MOVLW       hi_addr(?lstr4_MIDImon+0)
	MOVWF       FARG_UART1_Write_Line_uart_text+1 
	CALL        _UART1_Write_Line+0, 0
;MIDImon.c,131 :: 		UART1_Write_Line("c        RC3 Clock Toggle");
	MOVLW       ?lstr5_MIDImon+0
	MOVWF       FARG_UART1_Write_Line_uart_text+0 
	MOVLW       hi_addr(?lstr5_MIDImon+0)
	MOVWF       FARG_UART1_Write_Line_uart_text+1 
	CALL        _UART1_Write_Line+0, 0
;MIDImon.c,132 :: 		UART1_Write_Line("d        RC4 Data Toggle");
	MOVLW       ?lstr6_MIDImon+0
	MOVWF       FARG_UART1_Write_Line_uart_text+0 
	MOVLW       hi_addr(?lstr6_MIDImon+0)
	MOVWF       FARG_UART1_Write_Line_uart_text+1 
	CALL        _UART1_Write_Line+0, 0
;MIDImon.c,133 :: 		UART1_Write_Line("i        read all inputs");
	MOVLW       ?lstr7_MIDImon+0
	MOVWF       FARG_UART1_Write_Line_uart_text+0 
	MOVLW       hi_addr(?lstr7_MIDImon+0)
	MOVWF       FARG_UART1_Write_Line_uart_text+1 
	CALL        _UART1_Write_Line+0, 0
;MIDImon.c,134 :: 		UART1_Write_Line("in       set port n to all inputs");
	MOVLW       ?lstr8_MIDImon+0
	MOVWF       FARG_UART1_Write_Line_uart_text+0 
	MOVLW       hi_addr(?lstr8_MIDImon+0)
	MOVWF       FARG_UART1_Write_Line_uart_text+1 
	CALL        _UART1_Write_Line+0, 0
;MIDImon.c,135 :: 		UART1_Write_Line("l        LED Test");
	MOVLW       ?lstr9_MIDImon+0
	MOVWF       FARG_UART1_Write_Line_uart_text+0 
	MOVLW       hi_addr(?lstr9_MIDImon+0)
	MOVWF       FARG_UART1_Write_Line_uart_text+1 
	CALL        _UART1_Write_Line+0, 0
;MIDImon.c,136 :: 		UART1_Write_Line("o cc ..  Output hex to MIDI");
	MOVLW       ?lstr10_MIDImon+0
	MOVWF       FARG_UART1_Write_Line_uart_text+0 
	MOVLW       hi_addr(?lstr10_MIDImon+0)
	MOVWF       FARG_UART1_Write_Line_uart_text+1 
	CALL        _UART1_Write_Line+0, 0
;MIDImon.c,137 :: 		UART1_Write_Line("p        Parameter test");
	MOVLW       ?lstr11_MIDImon+0
	MOVWF       FARG_UART1_Write_Line_uart_text+0 
	MOVLW       hi_addr(?lstr11_MIDImon+0)
	MOVWF       FARG_UART1_Write_Line_uart_text+1 
	CALL        _UART1_Write_Line+0, 0
;MIDImon.c,138 :: 		UART1_Write_Line("z        Bassboy send test");
	MOVLW       ?lstr12_MIDImon+0
	MOVWF       FARG_UART1_Write_Line_uart_text+0 
	MOVLW       hi_addr(?lstr12_MIDImon+0)
	MOVWF       FARG_UART1_Write_Line_uart_text+1 
	CALL        _UART1_Write_Line+0, 0
;MIDImon.c,139 :: 		break;
	GOTO        L_main5
;MIDImon.c,141 :: 		default:{
L_main15:
;MIDImon.c,142 :: 		UART1_Write_Line("command not recognised");
	MOVLW       ?lstr13_MIDImon+0
	MOVWF       FARG_UART1_Write_Line_uart_text+0 
	MOVLW       hi_addr(?lstr13_MIDImon+0)
	MOVWF       FARG_UART1_Write_Line_uart_text+1 
	CALL        _UART1_Write_Line+0, 0
;MIDImon.c,143 :: 		break;
	GOTO        L_main5
;MIDImon.c,145 :: 		}
L_main4:
	MOVF        _newcmd+0, 0 
	XORLW       66
	BTFSC       STATUS+0, 2 
	GOTO        L_main6
	MOVF        _newcmd+0, 0 
	XORLW       67
	BTFSC       STATUS+0, 2 
	GOTO        L_main7
	MOVF        _newcmd+0, 0 
	XORLW       68
	BTFSC       STATUS+0, 2 
	GOTO        L_main8
	MOVF        _newcmd+0, 0 
	XORLW       73
	BTFSC       STATUS+0, 2 
	GOTO        L_main9
	MOVF        _newcmd+0, 0 
	XORLW       76
	BTFSC       STATUS+0, 2 
	GOTO        L_main10
	MOVF        _newcmd+0, 0 
	XORLW       79
	BTFSC       STATUS+0, 2 
	GOTO        L_main11
	MOVF        _newcmd+0, 0 
	XORLW       80
	BTFSC       STATUS+0, 2 
	GOTO        L_main12
	MOVF        _newcmd+0, 0 
	XORLW       90
	BTFSC       STATUS+0, 2 
	GOTO        L_main13
	MOVF        _newcmd+0, 0 
	XORLW       63
	BTFSC       STATUS+0, 2 
	GOTO        L_main14
	GOTO        L_main15
L_main5:
;MIDImon.c,146 :: 		}
	GOTO        L_main2
;MIDImon.c,147 :: 		}
L_end_main:
	GOTO        $+0
; end of _main

_cmdb:

;MIDImon.c,149 :: 		void cmdb(){
;MIDImon.c,150 :: 		if( nparams == 2){
	MOVF        _nparams+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_cmdb16
;MIDImon.c,151 :: 		TRISB  = 0;                                                             // Configure PORT as output
	CLRF        TRISB+0 
;MIDImon.c,152 :: 		LATB = upar[1];
	MOVF        _upar+2, 0 
	MOVWF       LATB+0 
;MIDImon.c,153 :: 		UART1_Write_Text("PORTB = 0x");
	MOVLW       ?lstr14_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr14_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,154 :: 		PrintHex(LATB);
	MOVF        LATB+0, 0 
	MOVWF       FARG_PrintHex_i+0 
	CALL        _PrintHex+0, 0
;MIDImon.c,155 :: 		UART1_Write_Text("\r\n");
	MOVLW       ?lstr15_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr15_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,156 :: 		}
	GOTO        L_cmdb17
L_cmdb16:
;MIDImon.c,158 :: 		UART1_Write_Line("must use form:   b nn");
	MOVLW       ?lstr16_MIDImon+0
	MOVWF       FARG_UART1_Write_Line_uart_text+0 
	MOVLW       hi_addr(?lstr16_MIDImon+0)
	MOVWF       FARG_UART1_Write_Line_uart_text+1 
	CALL        _UART1_Write_Line+0, 0
;MIDImon.c,159 :: 		}
L_cmdb17:
;MIDImon.c,160 :: 		}
L_end_cmdb:
	RETURN      0
; end of _cmdb

_cmdc:

;MIDImon.c,162 :: 		void cmdc(){
;MIDImon.c,163 :: 		LATC ^= 0x08;                                                               // toggle I2C clock on RC3
	BTG         LATC+0, 3 
;MIDImon.c,164 :: 		}
L_end_cmdc:
	RETURN      0
; end of _cmdc

_cmdd:

;MIDImon.c,166 :: 		void cmdd(){
;MIDImon.c,167 :: 		LATC ^= 0x10;                                                               // toggle I2C data on RC4
	BTG         LATC+0, 4 
;MIDImon.c,168 :: 		}
L_end_cmdd:
	RETURN      0
; end of _cmdd

_cmdi:

;MIDImon.c,171 :: 		void cmdi(){
;MIDImon.c,172 :: 		if(nparams == 1){
	MOVF        _nparams+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_cmdi18
;MIDImon.c,173 :: 		if( param[0][1] == 'A'){
	MOVF        _param+1, 0 
	XORLW       65
	BTFSS       STATUS+0, 2 
	GOTO        L_cmdi19
;MIDImon.c,174 :: 		TRISA = 0xff;                                                           // all input
	MOVLW       255
	MOVWF       TRISA+0 
;MIDImon.c,175 :: 		}
L_cmdi19:
;MIDImon.c,176 :: 		if( param[0][1] == 'B'){
	MOVF        _param+1, 0 
	XORLW       66
	BTFSS       STATUS+0, 2 
	GOTO        L_cmdi20
;MIDImon.c,177 :: 		TRISB = 0xff;                                                           // all input
	MOVLW       255
	MOVWF       TRISB+0 
;MIDImon.c,178 :: 		}
L_cmdi20:
;MIDImon.c,179 :: 		if( param[0][1] == 'C'){
	MOVF        _param+1, 0 
	XORLW       67
	BTFSS       STATUS+0, 2 
	GOTO        L_cmdi21
;MIDImon.c,180 :: 		TRISC = 0xbf;                                                           // all input  except Tx pin
	MOVLW       191
	MOVWF       TRISC+0 
;MIDImon.c,181 :: 		}
L_cmdi21:
;MIDImon.c,182 :: 		if( param[0][1] == 'D'){
	MOVF        _param+1, 0 
	XORLW       68
	BTFSS       STATUS+0, 2 
	GOTO        L_cmdi22
;MIDImon.c,183 :: 		TRISD = 0xff;                                                           // all input
	MOVLW       255
	MOVWF       TRISD+0 
;MIDImon.c,184 :: 		}
L_cmdi22:
;MIDImon.c,185 :: 		if( param[0][1] == 'E'){
	MOVF        _param+1, 0 
	XORLW       69
	BTFSS       STATUS+0, 2 
	GOTO        L_cmdi23
;MIDImon.c,186 :: 		TRISE = 0xff;                                                           // all input
	MOVLW       255
	MOVWF       TRISE+0 
;MIDImon.c,187 :: 		}
L_cmdi23:
;MIDImon.c,188 :: 		}
L_cmdi18:
;MIDImon.c,189 :: 		UART1_Write_Text("PORTA = 0x");
	MOVLW       ?lstr17_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr17_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,190 :: 		PrintHex(PORTA);
	MOVF        PORTA+0, 0 
	MOVWF       FARG_PrintHex_i+0 
	CALL        _PrintHex+0, 0
;MIDImon.c,191 :: 		UART1_Write_Text("\r\nPORTB = 0x");
	MOVLW       ?lstr18_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr18_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,192 :: 		PrintHex(PORTB);
	MOVF        PORTB+0, 0 
	MOVWF       FARG_PrintHex_i+0 
	CALL        _PrintHex+0, 0
;MIDImon.c,193 :: 		UART1_Write_Text("\r\nPORTC = 0x");
	MOVLW       ?lstr19_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr19_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,194 :: 		PrintHex(PORTC);
	MOVF        PORTC+0, 0 
	MOVWF       FARG_PrintHex_i+0 
	CALL        _PrintHex+0, 0
;MIDImon.c,195 :: 		UART1_Write_Text("\r\nPORTD = 0x");
	MOVLW       ?lstr20_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr20_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,196 :: 		PrintHex(PORTD);
	MOVF        PORTD+0, 0 
	MOVWF       FARG_PrintHex_i+0 
	CALL        _PrintHex+0, 0
;MIDImon.c,197 :: 		UART1_Write_Text("\r\nPORTE = 0x");
	MOVLW       ?lstr21_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr21_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,198 :: 		PrintHex(PORTE);
	MOVF        PORTE+0, 0 
	MOVWF       FARG_PrintHex_i+0 
	CALL        _PrintHex+0, 0
;MIDImon.c,199 :: 		UART1_Write_Text("\r\n");
	MOVLW       ?lstr22_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr22_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,200 :: 		}
L_end_cmdi:
	RETURN      0
; end of _cmdi

_cmdl:

;MIDImon.c,203 :: 		void cmdl(){
;MIDImon.c,205 :: 		UART1_Write_Text("LED TEST");
	MOVLW       ?lstr23_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr23_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,206 :: 		TRISB = 0;                                                                  // all output
	CLRF        TRISB+0 
;MIDImon.c,207 :: 		for( n=0 ; n < 10 ; n++){
	CLRF        cmdl_n_L0+0 
	CLRF        cmdl_n_L0+1 
L_cmdl24:
	MOVLW       0
	SUBWF       cmdl_n_L0+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__cmdl120
	MOVLW       10
	SUBWF       cmdl_n_L0+0, 0 
L__cmdl120:
	BTFSC       STATUS+0, 0 
	GOTO        L_cmdl25
;MIDImon.c,208 :: 		UART1_Write('.');
	MOVLW       46
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;MIDImon.c,209 :: 		LATB = 0x5555;
	MOVLW       85
	MOVWF       LATB+0 
;MIDImon.c,210 :: 		Delay_ms(300);
	MOVLW       13
	MOVWF       R11, 0
	MOVLW       45
	MOVWF       R12, 0
	MOVLW       215
	MOVWF       R13, 0
L_cmdl27:
	DECFSZ      R13, 1, 1
	BRA         L_cmdl27
	DECFSZ      R12, 1, 1
	BRA         L_cmdl27
	DECFSZ      R11, 1, 1
	BRA         L_cmdl27
	NOP
	NOP
;MIDImon.c,211 :: 		LATB = 0xaaaa;
	MOVLW       170
	MOVWF       LATB+0 
;MIDImon.c,212 :: 		Delay_ms(300);
	MOVLW       13
	MOVWF       R11, 0
	MOVLW       45
	MOVWF       R12, 0
	MOVLW       215
	MOVWF       R13, 0
L_cmdl28:
	DECFSZ      R13, 1, 1
	BRA         L_cmdl28
	DECFSZ      R12, 1, 1
	BRA         L_cmdl28
	DECFSZ      R11, 1, 1
	BRA         L_cmdl28
	NOP
	NOP
;MIDImon.c,207 :: 		for( n=0 ; n < 10 ; n++){
	INFSNZ      cmdl_n_L0+0, 1 
	INCF        cmdl_n_L0+1, 1 
;MIDImon.c,213 :: 		}
	GOTO        L_cmdl24
L_cmdl25:
;MIDImon.c,214 :: 		LATB = 0;
	CLRF        LATB+0 
;MIDImon.c,215 :: 		UART1_Write_Text("done\r\n");
	MOVLW       ?lstr24_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr24_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,216 :: 		}
L_end_cmdl:
	RETURN      0
; end of _cmdl

_cmdo:

;MIDImon.c,220 :: 		void cmdo(){
;MIDImon.c,223 :: 		UART1_Write_Text("MIDI out ");
	MOVLW       ?lstr25_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr25_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,224 :: 		for(pc = 1; pc < nparams; pc++){
	MOVLW       1
	MOVWF       cmdo_pc_L0+0 
L_cmdo29:
	MOVF        _nparams+0, 0 
	SUBWF       cmdo_pc_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_cmdo30
;MIDImon.c,225 :: 		UART2_Write(upar[pc]);
	MOVF        cmdo_pc_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       _upar+0
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       hi_addr(_upar+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_UART2_Write_data_+0 
	CALL        _UART2_Write+0, 0
;MIDImon.c,226 :: 		PrintHexSp(upar[pc]);
	MOVF        cmdo_pc_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       _upar+0
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       hi_addr(_upar+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_PrintHexSp_i+0 
	CALL        _PrintHexSp+0, 0
;MIDImon.c,224 :: 		for(pc = 1; pc < nparams; pc++){
	INCF        cmdo_pc_L0+0, 1 
;MIDImon.c,227 :: 		}
	GOTO        L_cmdo29
L_cmdo30:
;MIDImon.c,228 :: 		UART1_Write_Text("\r\n");
	MOVLW       ?lstr26_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr26_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,229 :: 		}
L_end_cmdo:
	RETURN      0
; end of _cmdo

_cmdp:

;MIDImon.c,231 :: 		void cmdp(){
;MIDImon.c,233 :: 		PrintHex(nparams);
	MOVF        _nparams+0, 0 
	MOVWF       FARG_PrintHex_i+0 
	CALL        _PrintHex+0, 0
;MIDImon.c,234 :: 		UART1_Write_Text(" parameters\r\n");
	MOVLW       ?lstr27_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr27_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,235 :: 		for( paramcount = 0 ; paramcount < 8 ; paramcount++ ){
	CLRF        cmdp_paramcount_L0+0 
L_cmdp32:
	MOVLW       8
	SUBWF       cmdp_paramcount_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_cmdp33
;MIDImon.c,236 :: 		UART1_Write_Text("parameter ");
	MOVLW       ?lstr28_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr28_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,237 :: 		PrintHexSp(paramcount);
	MOVF        cmdp_paramcount_L0+0, 0 
	MOVWF       FARG_PrintHexSp_i+0 
	CALL        _PrintHexSp+0, 0
;MIDImon.c,238 :: 		PrintHex((upar[paramcount] >> 8) & 0xff);
	MOVF        cmdp_paramcount_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       _upar+0
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       hi_addr(_upar+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R3 
	MOVF        POSTINC0+0, 0 
	MOVWF       R4 
	MOVF        R4, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVLW       255
	ANDWF       R0, 0 
	MOVWF       FARG_PrintHex_i+0 
	CALL        _PrintHex+0, 0
;MIDImon.c,239 :: 		PrintHex((upar[paramcount]) & 0xff);
	MOVF        cmdp_paramcount_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       _upar+0
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       hi_addr(_upar+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVLW       255
	ANDWF       POSTINC0+0, 0 
	MOVWF       FARG_PrintHex_i+0 
	CALL        _PrintHex+0, 0
;MIDImon.c,240 :: 		UART1_Write_Text("\r\n");
	MOVLW       ?lstr29_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr29_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,235 :: 		for( paramcount = 0 ; paramcount < 8 ; paramcount++ ){
	INCF        cmdp_paramcount_L0+0, 1 
;MIDImon.c,241 :: 		}
	GOTO        L_cmdp32
L_cmdp33:
;MIDImon.c,242 :: 		}
L_end_cmdp:
	RETURN      0
; end of _cmdp

_cmdz:

;MIDImon.c,260 :: 		void cmdz(){
;MIDImon.c,263 :: 		UART1_Write_Text("\r\nBassBoyMIDI out on RD6\r\n");
	MOVLW       ?lstr30_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr30_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,264 :: 		for(pc = 0; pc < sizeof(midi1); pc++){
	CLRF        cmdz_pc_L0+0 
L_cmdz35:
	MOVLW       9
	SUBWF       cmdz_pc_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_cmdz36
;MIDImon.c,265 :: 		UART2_Write(midi1[pc]);
	MOVLW       _midi1+0
	MOVWF       FSR0L+0 
	MOVLW       hi_addr(_midi1+0)
	MOVWF       FSR0L+1 
	MOVF        cmdz_pc_L0+0, 0 
	ADDWF       FSR0L+0, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0L+1, 1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_UART2_Write_data_+0 
	CALL        _UART2_Write+0, 0
;MIDImon.c,266 :: 		if(midi1[pc] > 127){                            // control byte
	MOVLW       _midi1+0
	MOVWF       FSR0L+0 
	MOVLW       hi_addr(_midi1+0)
	MOVWF       FSR0L+1 
	MOVF        cmdz_pc_L0+0, 0 
	ADDWF       FSR0L+0, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0L+1, 1 
	MOVF        POSTINC0+0, 0 
	SUBLW       127
	BTFSC       STATUS+0, 0 
	GOTO        L_cmdz38
;MIDImon.c,267 :: 		Delay_ms(2000);
	MOVLW       82
	MOVWF       R11, 0
	MOVLW       43
	MOVWF       R12, 0
	MOVLW       0
	MOVWF       R13, 0
L_cmdz39:
	DECFSZ      R13, 1, 1
	BRA         L_cmdz39
	DECFSZ      R12, 1, 1
	BRA         L_cmdz39
	DECFSZ      R11, 1, 1
	BRA         L_cmdz39
	NOP
;MIDImon.c,268 :: 		UART1_Write_Text("\r\n");
	MOVLW       ?lstr31_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr31_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,269 :: 		}
L_cmdz38:
;MIDImon.c,270 :: 		PrintHexSp(midi1[pc]);
	MOVLW       _midi1+0
	MOVWF       FSR0L+0 
	MOVLW       hi_addr(_midi1+0)
	MOVWF       FSR0L+1 
	MOVF        cmdz_pc_L0+0, 0 
	ADDWF       FSR0L+0, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0L+1, 1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_PrintHexSp_i+0 
	CALL        _PrintHexSp+0, 0
;MIDImon.c,264 :: 		for(pc = 0; pc < sizeof(midi1); pc++){
	INCF        cmdz_pc_L0+0, 1 
;MIDImon.c,272 :: 		}
	GOTO        L_cmdz35
L_cmdz36:
;MIDImon.c,273 :: 		midi_off();
	CALL        _midi_off+0, 0
;MIDImon.c,274 :: 		UART1_Write_Text("\r\n");
	MOVLW       ?lstr32_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr32_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,275 :: 		}
L_end_cmdz:
	RETURN      0
; end of _cmdz

_midi_off:

;MIDImon.c,278 :: 		void midi_off(){
;MIDImon.c,279 :: 		Delay_ms(2000);                                     // allow time to hear final note
	MOVLW       82
	MOVWF       R11, 0
	MOVLW       43
	MOVWF       R12, 0
	MOVLW       0
	MOVWF       R13, 0
L_midi_off40:
	DECFSZ      R13, 1, 1
	BRA         L_midi_off40
	DECFSZ      R12, 1, 1
	BRA         L_midi_off40
	DECFSZ      R11, 1, 1
	BRA         L_midi_off40
	NOP
;MIDImon.c,280 :: 		UART1_Write_Text("\r\nB0 7B 00 (all notes off)\r\n");
	MOVLW       ?lstr33_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr33_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,281 :: 		UART2_Write(0xb0);
	MOVLW       176
	MOVWF       FARG_UART2_Write_data_+0 
	CALL        _UART2_Write+0, 0
;MIDImon.c,282 :: 		UART2_Write(0x7b);
	MOVLW       123
	MOVWF       FARG_UART2_Write_data_+0 
	CALL        _UART2_Write+0, 0
;MIDImon.c,283 :: 		UART2_Write(0x00);
	CLRF        FARG_UART2_Write_data_+0 
	CALL        _UART2_Write+0, 0
;MIDImon.c,284 :: 		UART1_Write_Text("\r\ndone...\r\n");
	MOVLW       ?lstr34_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr34_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,285 :: 		}
L_end_midi_off:
	RETURN      0
; end of _midi_off

_UART1_Write_Line:

;MIDImon.c,288 :: 		void UART1_Write_Line(char *uart_text) {
;MIDImon.c,289 :: 		UART1_Write_Text(uart_text);
	MOVF        FARG_UART1_Write_Line_uart_text+0, 0 
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVF        FARG_UART1_Write_Line_uart_text+1, 0 
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,290 :: 		UART1_Write_Text("\r\n");
	MOVLW       ?lstr35_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr35_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,291 :: 		}
L_end_UART1_Write_Line:
	RETURN      0
; end of _UART1_Write_Line

_PrintHex:

;MIDImon.c,294 :: 		void PrintHex(unsigned char i) {
;MIDImon.c,297 :: 		hi = i & 0xF0;                                                              // high nibble
	MOVLW       240
	ANDWF       FARG_PrintHex_i+0, 0 
	MOVWF       R2 
	MOVF        R2, 0 
	MOVWF       PrintHex_hi_L0+0 
;MIDImon.c,298 :: 		hi = hi >> 4;
	MOVF        R2, 0 
	MOVWF       R0 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	MOVF        R0, 0 
	MOVWF       PrintHex_hi_L0+0 
;MIDImon.c,299 :: 		hi = hi + '0';
	MOVLW       48
	ADDWF       R0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       PrintHex_hi_L0+0 
;MIDImon.c,300 :: 		if (hi > '9') hi = hi + 7;
	MOVF        R1, 0 
	SUBLW       57
	BTFSC       STATUS+0, 0 
	GOTO        L_PrintHex41
	MOVLW       7
	ADDWF       PrintHex_hi_L0+0, 1 
L_PrintHex41:
;MIDImon.c,301 :: 		lo = (i & 0x0F) + '0';                                                      // low nibble
	MOVLW       15
	ANDWF       FARG_PrintHex_i+0, 0 
	MOVWF       R0 
	MOVLW       48
	ADDWF       R0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       PrintHex_lo_L0+0 
;MIDImon.c,302 :: 		if (lo>'9') lo=lo+7;
	MOVF        R1, 0 
	SUBLW       57
	BTFSC       STATUS+0, 0 
	GOTO        L_PrintHex42
	MOVLW       7
	ADDWF       PrintHex_lo_L0+0, 1 
L_PrintHex42:
;MIDImon.c,304 :: 		UART1_Write(hi);
	MOVF        PrintHex_hi_L0+0, 0 
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;MIDImon.c,305 :: 		UART1_Write(lo);
	MOVF        PrintHex_lo_L0+0, 0 
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;MIDImon.c,306 :: 		}
L_end_PrintHex:
	RETURN      0
; end of _PrintHex

_PrintHexSp:

;MIDImon.c,309 :: 		void PrintHexSp(unsigned char i) {
;MIDImon.c,312 :: 		hi = i & 0xF0;                                                              // high nibble
	MOVLW       240
	ANDWF       FARG_PrintHexSp_i+0, 0 
	MOVWF       R2 
	MOVF        R2, 0 
	MOVWF       PrintHexSp_hi_L0+0 
;MIDImon.c,313 :: 		hi = hi >> 4;
	MOVF        R2, 0 
	MOVWF       R0 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	MOVF        R0, 0 
	MOVWF       PrintHexSp_hi_L0+0 
;MIDImon.c,314 :: 		hi = hi + '0';
	MOVLW       48
	ADDWF       R0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       PrintHexSp_hi_L0+0 
;MIDImon.c,315 :: 		if (hi > '9') hi = hi + 7;
	MOVF        R1, 0 
	SUBLW       57
	BTFSC       STATUS+0, 0 
	GOTO        L_PrintHexSp43
	MOVLW       7
	ADDWF       PrintHexSp_hi_L0+0, 1 
L_PrintHexSp43:
;MIDImon.c,316 :: 		lo = (i & 0x0F) + '0';                                                      // low nibble
	MOVLW       15
	ANDWF       FARG_PrintHexSp_i+0, 0 
	MOVWF       R0 
	MOVLW       48
	ADDWF       R0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       PrintHexSp_lo_L0+0 
;MIDImon.c,317 :: 		if (lo>'9') lo=lo+7;
	MOVF        R1, 0 
	SUBLW       57
	BTFSC       STATUS+0, 0 
	GOTO        L_PrintHexSp44
	MOVLW       7
	ADDWF       PrintHexSp_lo_L0+0, 1 
L_PrintHexSp44:
;MIDImon.c,319 :: 		UART1_Write(hi);
	MOVF        PrintHexSp_hi_L0+0, 0 
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;MIDImon.c,320 :: 		UART1_Write(lo);
	MOVF        PrintHexSp_lo_L0+0, 0 
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;MIDImon.c,321 :: 		UART1_Write(' ');
	MOVLW       32
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;MIDImon.c,322 :: 		}
L_end_PrintHexSp:
	RETURN      0
; end of _PrintHexSp

_getparams:

;MIDImon.c,325 :: 		char getparams(char* tempstring){
;MIDImon.c,330 :: 		unsigned int         pointer1=0;                                                // pointer within string
	CLRF        getparams_pointer1_L0+0 
	CLRF        getparams_pointer1_L0+1 
	CLRF        getparams_pointer2_L0+0 
	CLRF        getparams_pointer2_L0+1 
;MIDImon.c,333 :: 		oldcmd=cmd;                                                                 // remember old value
	MOVF        _cmd+0, 0 
	MOVWF       getparams_oldcmd_L0+0 
;MIDImon.c,334 :: 		nparams = 0;                                                                // initialise
	CLRF        _nparams+0 
;MIDImon.c,335 :: 		pointer1 = 0;                                                               // initialise
	CLRF        getparams_pointer1_L0+0 
	CLRF        getparams_pointer1_L0+1 
;MIDImon.c,337 :: 		for ( n = 0 ; n < 8 ; n++){                                                 // count 0 to 7
	CLRF        getparams_n_L0+0 
	CLRF        getparams_n_L0+1 
L_getparams45:
	MOVLW       128
	XORWF       getparams_n_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getparams129
	MOVLW       8
	SUBWF       getparams_n_L0+0, 0 
L__getparams129:
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams46
;MIDImon.c,339 :: 		tempchar=1;                                                             // init
	MOVLW       1
	MOVWF       getparams_tempchar_L0+0 
;MIDImon.c,340 :: 		do {
L_getparams48:
;MIDImon.c,341 :: 		tempchar = tempstring[pointer1++];
	MOVF        getparams_pointer1_L0+0, 0 
	ADDWF       FARG_getparams_tempstring+0, 0 
	MOVWF       FSR0L+0 
	MOVF        getparams_pointer1_L0+1, 0 
	ADDWFC      FARG_getparams_tempstring+1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       getparams_tempchar_L0+0 
	INFSNZ      getparams_pointer1_L0+0, 1 
	INCF        getparams_pointer1_L0+1, 1 
;MIDImon.c,342 :: 		} while (tempchar == 0x20);
	MOVF        R1, 0 
	XORLW       32
	BTFSC       STATUS+0, 2 
	GOTO        L_getparams48
;MIDImon.c,343 :: 		pointer1--;                                                             // leave pointer after param
	MOVLW       1
	SUBWF       getparams_pointer1_L0+0, 1 
	MOVLW       0
	SUBWFB      getparams_pointer1_L0+1, 1 
;MIDImon.c,346 :: 		if ((tempchar != 0) && (nparams < 8)){
	MOVF        getparams_tempchar_L0+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_getparams53
	MOVLW       8
	SUBWF       _nparams+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams53
L__getparams111:
;MIDImon.c,347 :: 		nparams++;
	INCF        _nparams+0, 1 
;MIDImon.c,348 :: 		}
L_getparams53:
;MIDImon.c,350 :: 		if (n == 0){                                                            // only for param 0
	MOVLW       0
	XORWF       getparams_n_L0+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getparams130
	MOVLW       0
	XORWF       getparams_n_L0+0, 0 
L__getparams130:
	BTFSS       STATUS+0, 2 
	GOTO        L_getparams54
;MIDImon.c,351 :: 		tempchar=tempstring[pointer1];                                      // get only first letter
	MOVF        getparams_pointer1_L0+0, 0 
	ADDWF       FARG_getparams_tempstring+0, 0 
	MOVWF       FSR0L+0 
	MOVF        getparams_pointer1_L0+1, 0 
	ADDWFC      FARG_getparams_tempstring+1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       getparams_tempchar_L0+0 
;MIDImon.c,352 :: 		if ((tempchar > 0x60) && (tempchar < 0x7b)) {
	MOVF        R1, 0 
	SUBLW       96
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams57
	MOVLW       123
	SUBWF       getparams_tempchar_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams57
L__getparams110:
;MIDImon.c,353 :: 		tempchar -= 0x20;                                               // to upper case
	MOVLW       32
	SUBWF       getparams_tempchar_L0+0, 1 
;MIDImon.c,354 :: 		}
L_getparams57:
;MIDImon.c,355 :: 		cmd=tempchar;
	MOVF        getparams_tempchar_L0+0, 0 
	MOVWF       _cmd+0 
;MIDImon.c,356 :: 		}
L_getparams54:
;MIDImon.c,358 :: 		tempchar=1;                                                             // initialise
	MOVLW       1
	MOVWF       getparams_tempchar_L0+0 
;MIDImon.c,359 :: 		if (nparams != 0){                                                      // only for non-blank line
	MOVF        _nparams+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_getparams58
;MIDImon.c,361 :: 		pointer2=0;                                                         // initialise
	CLRF        getparams_pointer2_L0+0 
	CLRF        getparams_pointer2_L0+1 
;MIDImon.c,362 :: 		do {
L_getparams59:
;MIDImon.c,363 :: 		tempchar = tempstring[pointer1++];                              // get char
	MOVF        getparams_pointer1_L0+0, 0 
	ADDWF       FARG_getparams_tempstring+0, 0 
	MOVWF       FSR0L+0 
	MOVF        getparams_pointer1_L0+1, 0 
	ADDWFC      FARG_getparams_tempstring+1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       getparams_tempchar_L0+0 
	INFSNZ      getparams_pointer1_L0+0, 1 
	INCF        getparams_pointer1_L0+1, 1 
;MIDImon.c,364 :: 		if ((tempchar > 0x60) && (tempchar < 0x7b)) {
	MOVF        R1, 0 
	SUBLW       96
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams64
	MOVLW       123
	SUBWF       getparams_tempchar_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams64
L__getparams109:
;MIDImon.c,365 :: 		tempchar -= 0x20;                                           // to upper case
	MOVLW       32
	SUBWF       getparams_tempchar_L0+0, 1 
;MIDImon.c,366 :: 		}
L_getparams64:
;MIDImon.c,367 :: 		param[n][pointer2++] = tempchar;                                // and store it
	MOVLW       20
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        getparams_n_L0+0, 0 
	MOVWF       R4 
	MOVF        getparams_n_L0+1, 0 
	MOVWF       R5 
	CALL        _Mul_16X16_U+0, 0
	MOVLW       _param+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_param+0)
	ADDWFC      R1, 1 
	MOVF        getparams_pointer2_L0+0, 0 
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVF        getparams_pointer2_L0+1, 0 
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	MOVF        getparams_tempchar_L0+0, 0 
	MOVWF       POSTINC1+0 
	INFSNZ      getparams_pointer2_L0+0, 1 
	INCF        getparams_pointer2_L0+1, 1 
;MIDImon.c,368 :: 		} while ((tempchar > 0x20) && (tempchar < 0x7f) && (pointer2 < 20)); // text
	MOVF        getparams_tempchar_L0+0, 0 
	SUBLW       32
	BTFSC       STATUS+0, 0 
	GOTO        L__getparams108
	MOVLW       127
	SUBWF       getparams_tempchar_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L__getparams108
	MOVLW       0
	SUBWF       getparams_pointer2_L0+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getparams131
	MOVLW       20
	SUBWF       getparams_pointer2_L0+0, 0 
L__getparams131:
	BTFSC       STATUS+0, 0 
	GOTO        L__getparams108
	GOTO        L_getparams59
L__getparams108:
;MIDImon.c,369 :: 		param[n][pointer2-1]=0;                                             // zero terminate param string
	MOVLW       20
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        getparams_n_L0+0, 0 
	MOVWF       R4 
	MOVF        getparams_n_L0+1, 0 
	MOVWF       R5 
	CALL        _Mul_16X16_U+0, 0
	MOVLW       _param+0
	ADDWF       R0, 0 
	MOVWF       R2 
	MOVLW       hi_addr(_param+0)
	ADDWFC      R1, 0 
	MOVWF       R3 
	MOVLW       1
	SUBWF       getparams_pointer2_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	SUBWFB      getparams_pointer2_L0+1, 0 
	MOVWF       R1 
	MOVF        R0, 0 
	ADDWF       R2, 0 
	MOVWF       FSR1L+0 
	MOVF        R1, 0 
	ADDWFC      R3, 0 
	MOVWF       FSR1L+1 
	CLRF        POSTINC1+0 
;MIDImon.c,370 :: 		if((tempchar == 0)||(n == 9)){                                      // no more params if end of line
	MOVF        getparams_tempchar_L0+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L__getparams107
	MOVLW       0
	XORWF       getparams_n_L0+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getparams132
	MOVLW       9
	XORWF       getparams_n_L0+0, 0 
L__getparams132:
	BTFSC       STATUS+0, 2 
	GOTO        L__getparams107
	GOTO        L_getparams69
L__getparams107:
;MIDImon.c,371 :: 		break;
	GOTO        L_getparams46
;MIDImon.c,372 :: 		}
L_getparams69:
;MIDImon.c,373 :: 		}
L_getparams58:
;MIDImon.c,337 :: 		for ( n = 0 ; n < 8 ; n++){                                                 // count 0 to 7
	INFSNZ      getparams_n_L0+0, 1 
	INCF        getparams_n_L0+1, 1 
;MIDImon.c,374 :: 		}
	GOTO        L_getparams45
L_getparams46:
;MIDImon.c,377 :: 		for (n = 0; n < nparams ; n++){                                             // parms are 0 to 7
	CLRF        getparams_n_L0+0 
	CLRF        getparams_n_L0+1 
L_getparams70:
	MOVLW       128
	XORWF       getparams_n_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getparams133
	MOVF        _nparams+0, 0 
	SUBWF       getparams_n_L0+0, 0 
L__getparams133:
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams71
;MIDImon.c,378 :: 		tempchar2=1;                                                            // initialise
	MOVLW       1
	MOVWF       getparams_tempchar2_L0+0 
;MIDImon.c,379 :: 		pointer1=0;                                                             // initialise
	CLRF        getparams_pointer1_L0+0 
	CLRF        getparams_pointer1_L0+1 
;MIDImon.c,380 :: 		upar[n]=0;                                                              // initialise
	MOVF        getparams_n_L0+0, 0 
	MOVWF       R0 
	MOVF        getparams_n_L0+1, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       _upar+0
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       hi_addr(_upar+0)
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
;MIDImon.c,381 :: 		do {
L_getparams73:
;MIDImon.c,382 :: 		tempchar = param[n][pointer1++];
	MOVLW       20
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        getparams_n_L0+0, 0 
	MOVWF       R4 
	MOVF        getparams_n_L0+1, 0 
	MOVWF       R5 
	CALL        _Mul_16X16_U+0, 0
	MOVLW       _param+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_param+0)
	ADDWFC      R1, 1 
	MOVF        getparams_pointer1_L0+0, 0 
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVF        getparams_pointer1_L0+1, 0 
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       getparams_tempchar_L0+0 
	INFSNZ      getparams_pointer1_L0+0, 1 
	INCF        getparams_pointer1_L0+1, 1 
;MIDImon.c,384 :: 		if ( tempchar != 0 ){
	MOVF        R1, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_getparams76
;MIDImon.c,385 :: 		upar[n] = upar[n] * 0x10;                                       // next most signicant hex digit
	MOVF        getparams_n_L0+0, 0 
	MOVWF       R0 
	MOVF        getparams_n_L0+1, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       _upar+0
	ADDWF       R0, 0 
	MOVWF       R5 
	MOVLW       hi_addr(_upar+0)
	ADDWFC      R1, 0 
	MOVWF       R6 
	MOVFF       R5, FSR0L+0
	MOVFF       R6, FSR0H+0
	MOVF        POSTINC0+0, 0 
	MOVWF       R3 
	MOVF        POSTINC0+0, 0 
	MOVWF       R4 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVFF       R5, FSR1L+0
	MOVFF       R6, FSR1H+0
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
;MIDImon.c,386 :: 		}            tempchar2=tempchar;
L_getparams76:
	MOVF        getparams_tempchar_L0+0, 0 
	MOVWF       getparams_tempchar2_L0+0 
;MIDImon.c,388 :: 		if ((tempchar < 0x30) || (tempchar > 0x46)) {
	MOVLW       48
	SUBWF       getparams_tempchar_L0+0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__getparams106
	MOVF        getparams_tempchar_L0+0, 0 
	SUBLW       70
	BTFSS       STATUS+0, 0 
	GOTO        L__getparams106
	GOTO        L_getparams79
L__getparams106:
;MIDImon.c,389 :: 		tempchar = 0x00;                                                // non-hex to zero
	CLRF        getparams_tempchar_L0+0 
;MIDImon.c,390 :: 		}
L_getparams79:
;MIDImon.c,391 :: 		if ((tempchar > 0x39) && (tempchar < 0x41)) {
	MOVF        getparams_tempchar_L0+0, 0 
	SUBLW       57
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams82
	MOVLW       65
	SUBWF       getparams_tempchar_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams82
L__getparams105:
;MIDImon.c,392 :: 		tempchar = 0x00;                                                // non-hex to zero
	CLRF        getparams_tempchar_L0+0 
;MIDImon.c,393 :: 		}
L_getparams82:
;MIDImon.c,394 :: 		if ((tempchar > 0x40) && (tempchar < 0x47)) {
	MOVF        getparams_tempchar_L0+0, 0 
	SUBLW       64
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams85
	MOVLW       71
	SUBWF       getparams_tempchar_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams85
L__getparams104:
;MIDImon.c,395 :: 		tempchar -= 0x37;                                               // to bin
	MOVLW       55
	SUBWF       getparams_tempchar_L0+0, 1 
;MIDImon.c,396 :: 		}
L_getparams85:
;MIDImon.c,397 :: 		if ((tempchar > 0x2f) && (tempchar < 0x3a)) {
	MOVF        getparams_tempchar_L0+0, 0 
	SUBLW       47
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams88
	MOVLW       58
	SUBWF       getparams_tempchar_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams88
L__getparams103:
;MIDImon.c,398 :: 		tempchar -= 0x30;                                               // to bin
	MOVLW       48
	SUBWF       getparams_tempchar_L0+0, 1 
;MIDImon.c,399 :: 		}
L_getparams88:
;MIDImon.c,400 :: 		upar[n] += tempchar;
	MOVF        getparams_n_L0+0, 0 
	MOVWF       R0 
	MOVF        getparams_n_L0+1, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       _upar+0
	ADDWF       R0, 0 
	MOVWF       R2 
	MOVLW       hi_addr(_upar+0)
	ADDWFC      R1, 0 
	MOVWF       R3 
	MOVFF       R2, FSR0L+0
	MOVFF       R3, FSR0H+0
	MOVF        getparams_tempchar_L0+0, 0 
	ADDWF       POSTINC0+0, 0 
	MOVWF       R0 
	MOVLW       0
	ADDWFC      POSTINC0+0, 0 
	MOVWF       R1 
	MOVFF       R2, FSR1L+0
	MOVFF       R3, FSR1H+0
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
;MIDImon.c,401 :: 		} while (tempchar2 != 0);
	MOVF        getparams_tempchar2_L0+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_getparams73
;MIDImon.c,377 :: 		for (n = 0; n < nparams ; n++){                                             // parms are 0 to 7
	INFSNZ      getparams_n_L0+0, 1 
	INCF        getparams_n_L0+1, 1 
;MIDImon.c,402 :: 		}
	GOTO        L_getparams70
L_getparams71:
;MIDImon.c,404 :: 		if (nparams == 0) {
	MOVF        _nparams+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_getparams89
;MIDImon.c,405 :: 		cmd = oldcmd;
	MOVF        getparams_oldcmd_L0+0, 0 
	MOVWF       _cmd+0 
;MIDImon.c,406 :: 		}
L_getparams89:
;MIDImon.c,407 :: 		return cmd;
	MOVF        _cmd+0, 0 
	MOVWF       R0 
;MIDImon.c,408 :: 		}
L_end_getparams:
	RETURN      0
; end of _getparams

_linein:

;MIDImon.c,414 :: 		void linein(char* pstring){
;MIDImon.c,415 :: 		char inChar = 0;
	CLRF        linein_inChar_L0+0 
;MIDImon.c,417 :: 		while(inChar != '\r'){
L_linein90:
	MOVF        linein_inChar_L0+0, 0 
	XORLW       13
	BTFSC       STATUS+0, 2 
	GOTO        L_linein91
;MIDImon.c,420 :: 		if (UART1_Data_Ready()){
	CALL        _UART1_Data_Ready+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_linein92
;MIDImon.c,421 :: 		inChar = UART1_Read();
	CALL        _UART1_Read+0, 0
	MOVF        R0, 0 
	MOVWF       linein_inChar_L0+0 
;MIDImon.c,422 :: 		UART1_Write(inChar);
	MOVF        R0, 0 
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;MIDImon.c,423 :: 		if(inChar == '\r'){
	MOVF        linein_inChar_L0+0, 0 
	XORLW       13
	BTFSS       STATUS+0, 2 
	GOTO        L_linein93
;MIDImon.c,424 :: 		UART1_Write('\n');
	MOVLW       10
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;MIDImon.c,425 :: 		*pstring ++= '\0';
	MOVFF       FARG_linein_pstring+0, FSR1L+0
	MOVFF       FARG_linein_pstring+1, FSR1H+0
	CLRF        POSTINC1+0 
	INFSNZ      FARG_linein_pstring+0, 1 
	INCF        FARG_linein_pstring+1, 1 
;MIDImon.c,426 :: 		}
	GOTO        L_linein94
L_linein93:
;MIDImon.c,428 :: 		if (inChar != 0x7f ){                                           // if not backspace
	MOVF        linein_inChar_L0+0, 0 
	XORLW       127
	BTFSC       STATUS+0, 2 
	GOTO        L_linein95
;MIDImon.c,429 :: 		*pstring++ = inChar;
	MOVFF       FARG_linein_pstring+0, FSR1L+0
	MOVFF       FARG_linein_pstring+1, FSR1H+0
	MOVF        linein_inChar_L0+0, 0 
	MOVWF       POSTINC1+0 
	INFSNZ      FARG_linein_pstring+0, 1 
	INCF        FARG_linein_pstring+1, 1 
;MIDImon.c,430 :: 		}
L_linein95:
;MIDImon.c,431 :: 		if (inChar == 0x7f ){                                           // handle backspace
	MOVF        linein_inChar_L0+0, 0 
	XORLW       127
	BTFSS       STATUS+0, 2 
	GOTO        L_linein96
;MIDImon.c,432 :: 		*--pstring = 0x00;
	MOVLW       1
	SUBWF       FARG_linein_pstring+0, 1 
	MOVLW       0
	SUBWFB      FARG_linein_pstring+1, 1 
	MOVFF       FARG_linein_pstring+0, FSR1L+0
	MOVFF       FARG_linein_pstring+1, FSR1H+0
	CLRF        POSTINC1+0 
;MIDImon.c,433 :: 		}
L_linein96:
;MIDImon.c,434 :: 		}
L_linein94:
;MIDImon.c,435 :: 		}
L_linein92:
;MIDImon.c,436 :: 		if(u2_rx_flag){
	MOVF        _u2_rx_flag+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_linein97
;MIDImon.c,437 :: 		u2_rx_flag = 0;
	CLRF        _u2_rx_flag+0 
;MIDImon.c,438 :: 		if(u2_rx_data > 127){
	MOVF        _u2_rx_data+0, 0 
	SUBLW       127
	BTFSC       STATUS+0, 0 
	GOTO        L_linein98
;MIDImon.c,439 :: 		UART1_Write_Text("\r\n");
	MOVLW       ?lstr36_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr36_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,440 :: 		UART1_Write_Text(int_rx_buf);                                       //
	MOVLW       _int_rx_buf+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(_int_rx_buf+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,441 :: 		}
	GOTO        L_linein99
L_linein98:
;MIDImon.c,443 :: 		UART1_Write_Text("-");
	MOVLW       ?lstr37_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr37_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,444 :: 		UART1_Write_Text(int_rx_buf);                                       //
	MOVLW       _int_rx_buf+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(_int_rx_buf+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,445 :: 		}
L_linein99:
;MIDImon.c,446 :: 		}
L_linein97:
;MIDImon.c,447 :: 		}
	GOTO        L_linein90
L_linein91:
;MIDImon.c,448 :: 		}
L_end_linein:
	RETURN      0
; end of _linein

_chin:

;MIDImon.c,451 :: 		char chin(void){
;MIDImon.c,454 :: 		while(!UART1_Data_Ready());
L_chin100:
	CALL        _UART1_Data_Ready+0, 0
	MOVF        R0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_chin101
	GOTO        L_chin100
L_chin101:
;MIDImon.c,455 :: 		temp = UART1_Read();
	CALL        _UART1_Read+0, 0
;MIDImon.c,456 :: 		return temp;
;MIDImon.c,457 :: 		}
L_end_chin:
	RETURN      0
; end of _chin

_chout:

;MIDImon.c,460 :: 		void chout(char outchar){
;MIDImon.c,462 :: 		UART1_Write(outchar);
	MOVF        FARG_chout_outchar+0, 0 
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;MIDImon.c,463 :: 		if(outchar == 0x0d){
	MOVF        FARG_chout_outchar+0, 0 
	XORLW       13
	BTFSS       STATUS+0, 2 
	GOTO        L_chout102
;MIDImon.c,464 :: 		UART1_Write(0x0a);
	MOVLW       10
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;MIDImon.c,465 :: 		}
L_chout102:
;MIDImon.c,466 :: 		}
L_end_chout:
	RETURN      0
; end of _chout
