#line 1 "C:/PIC/MikroC/PIC18/PIC18F45K22/MIDI/MIDImon/MIDImon.c"
#line 24 "C:/PIC/MikroC/PIC18/PIC18F45K22/MIDI/MIDImon/MIDImon.c"
void UART1_Write_Line(char *uart_text);
void linein(char* pstring);
char getparams(char* tempstring);
void PrintHex(unsigned char i);
void PrintHexSp(unsigned char i);
void midi_off(void);


void cmdb(void);
void cmdc(void);
void cmdd(void);
void cmdi(void);
void cmdl(void);
void cmdo(void);
void cmdp(void);
void cmdz(void);


char rxbuff[20];
char rxidx;
unsigned char newcmd;
unsigned char cmd;
unsigned char u1_rx_data;
unsigned char u1_rx_flag = 0;
unsigned char u2_rx_data;
unsigned char u2_rx_flag = 0;
unsigned char linebuff[120];
unsigned char param[8][20];
unsigned int upar[8];
unsigned char nparams;
unsigned char int_rx_buf[4];
unsigned char midi1[] = {0xb0, 0x3a, 0x7f
 , 0x90, 0x30, 0x7f , 0x90, 0x35, 0x7f
 };

void interrupt() {
 if(RC2IF_bit == 1) {
 u2_rx_data = UART2_Read();
 ByteToHex(u2_rx_data, int_rx_buf);
 u2_rx_flag = 1;
 }
}

void main() {
 rxidx = 0;
 ANSELB = 0;
 ANSELC = 0;
 ANSELD = 0;
 TRISB = 0;
 TRISC = 0;
 TRISD = 0;
 LATB = 0x00;
 LATC = 0x00;
 LATD = 0x00;
 UART1_Init(115200);
 UART2_Init(31250);
 Delay_ms(100);
 newcmd = '?';
 cmd = newcmd;

 UART1_Write_Line("\r\nMIDI Monitor 29 Aug 2019");
 UART1_Write_Line("? for help");

 RC2IE_bit = 1;
 RC2IF_bit = 0;
 PEIE_bit = 1;
 GIE_bit = 1;

 while(1){
 linein(linebuff);
 newcmd = getparams(linebuff);
 switch(newcmd){
 case 'B':
 cmdb();
 break;

 case 'C':
 cmdc();
 break;

 case 'D':
 cmdd();
 break;

 case 'I':
 cmdi();
 break;

 case 'L':
 cmdl();
 break;

 case 'O':
 cmdo();
 break;

 case 'P':
 cmdp();
 break;

 case 'Z':
 cmdz();
 break;

 case '?':
 UART1_Write_Line("?        List Commands");
 UART1_Write_Line("b nn     Output hex nn to PORT B");
 UART1_Write_Line("c        RC3 Clock Toggle");
 UART1_Write_Line("d        RC4 Data Toggle");
 UART1_Write_Line("i        read all inputs");
 UART1_Write_Line("in       set port n to all inputs");
 UART1_Write_Line("l        LED Test");
 UART1_Write_Line("o cc ..  Output hex to MIDI");
 UART1_Write_Line("p        Parameter test");
 UART1_Write_Line("z        Bassboy send test");
 break;

 default:{
 UART1_Write_Line("command not recognised");
 break;
 }
 }
 }
}

void cmdb(){
 if( nparams == 2){
 TRISB = 0;
 LATB = upar[1];
 UART1_Write_Text("PORTB = 0x");
 PrintHex(LATB);
 UART1_Write_Text("\r\n");
 }
 else{
 UART1_Write_Line("must use form:   b nn");
 }
}

void cmdc(){
 LATC ^= 0x08;
}

void cmdd(){
 LATC ^= 0x10;
}


void cmdi(){
 if(nparams == 1){
 if( param[0][1] == 'A'){
 TRISA = 0xff;
 }
 if( param[0][1] == 'B'){
 TRISB = 0xff;
 }
 if( param[0][1] == 'C'){
 TRISC = 0xbf;
 }
 if( param[0][1] == 'D'){
 TRISD = 0xff;
 }
 if( param[0][1] == 'E'){
 TRISE = 0xff;
 }
 }
 UART1_Write_Text("PORTA = 0x");
 PrintHex(PORTA);
 UART1_Write_Text("\r\nPORTB = 0x");
 PrintHex(PORTB);
 UART1_Write_Text("\r\nPORTC = 0x");
 PrintHex(PORTC);
 UART1_Write_Text("\r\nPORTD = 0x");
 PrintHex(PORTD);
 UART1_Write_Text("\r\nPORTE = 0x");
 PrintHex(PORTE);
 UART1_Write_Text("\r\n");
}


void cmdl(){
unsigned int n;
 UART1_Write_Text("LED TEST");
 TRISB = 0;
 for( n=0 ; n < 10 ; n++){
 UART1_Write('.');
 LATB = 0x5555;
 Delay_ms(300);
 LATB = 0xaaaa;
 Delay_ms(300);
 }
 LATB = 0;
 UART1_Write_Text("done\r\n");
}



void cmdo(){
unsigned char pc;

 UART1_Write_Text("MIDI out ");
 for(pc = 1; pc < nparams; pc++){
 UART2_Write(upar[pc]);
 PrintHexSp(upar[pc]);
 }
 UART1_Write_Text("\r\n");
}

void cmdp(){
 unsigned char paramcount;
 PrintHex(nparams);
 UART1_Write_Text(" parameters\r\n");
 for( paramcount = 0 ; paramcount < 8 ; paramcount++ ){
 UART1_Write_Text("parameter ");
 PrintHexSp(paramcount);
 PrintHex((upar[paramcount] >> 8) & 0xff);
 PrintHex((upar[paramcount]) & 0xff);
 UART1_Write_Text("\r\n");
 }
}
#line 260 "C:/PIC/MikroC/PIC18/PIC18F45K22/MIDI/MIDImon/MIDImon.c"
void cmdz(){
unsigned char pc;

 UART1_Write_Text("\r\nBassBoyMIDI out on RD6\r\n");
 for(pc = 0; pc < sizeof(midi1); pc++){
 UART2_Write(midi1[pc]);
 if(midi1[pc] > 127){
 Delay_ms(2000);
 UART1_Write_Text("\r\n");
 }
 PrintHexSp(midi1[pc]);

 }
 midi_off();
 UART1_Write_Text("\r\n");
}


void midi_off(){
 Delay_ms(2000);
 UART1_Write_Text("\r\nB0 7B 00 (all notes off)\r\n");
 UART2_Write(0xb0);
 UART2_Write(0x7b);
 UART2_Write(0x00);
 UART1_Write_Text("\r\ndone...\r\n");
}


void UART1_Write_Line(char *uart_text) {
 UART1_Write_Text(uart_text);
 UART1_Write_Text("\r\n");
}


void PrintHex(unsigned char i) {
unsigned char hi,lo;

 hi = i & 0xF0;
 hi = hi >> 4;
 hi = hi + '0';
 if (hi > '9') hi = hi + 7;
 lo = (i & 0x0F) + '0';
 if (lo>'9') lo=lo+7;

 UART1_Write(hi);
 UART1_Write(lo);
}


void PrintHexSp(unsigned char i) {
unsigned char hi,lo;

 hi = i & 0xF0;
 hi = hi >> 4;
 hi = hi + '0';
 if (hi > '9') hi = hi + 7;
 lo = (i & 0x0F) + '0';
 if (lo>'9') lo=lo+7;

 UART1_Write(hi);
 UART1_Write(lo);
 UART1_Write(' ');
}


char getparams(char* tempstring){
char oldcmd;
int n;
char tempchar;
char tempchar2;
unsigned int pointer1=0;
unsigned int pointer2=0;

 oldcmd=cmd;
 nparams = 0;
 pointer1 = 0;

 for ( n = 0 ; n < 8 ; n++){

 tempchar=1;
 do {
 tempchar = tempstring[pointer1++];
 } while (tempchar == 0x20);
 pointer1--;


 if ((tempchar != 0) && (nparams < 8)){
 nparams++;
 }

 if (n == 0){
 tempchar=tempstring[pointer1];
 if ((tempchar > 0x60) && (tempchar < 0x7b)) {
 tempchar -= 0x20;
 }
 cmd=tempchar;
 }

 tempchar=1;
 if (nparams != 0){

 pointer2=0;
 do {
 tempchar = tempstring[pointer1++];
 if ((tempchar > 0x60) && (tempchar < 0x7b)) {
 tempchar -= 0x20;
 }
 param[n][pointer2++] = tempchar;
 } while ((tempchar > 0x20) && (tempchar < 0x7f) && (pointer2 < 20));
 param[n][pointer2-1]=0;
 if((tempchar == 0)||(n == 9)){
 break;
 }
 }
 }


 for (n = 0; n < nparams ; n++){
 tempchar2=1;
 pointer1=0;
 upar[n]=0;
 do {
 tempchar = param[n][pointer1++];

 if ( tempchar != 0 ){
 upar[n] = upar[n] * 0x10;
 } tempchar2=tempchar;

 if ((tempchar < 0x30) || (tempchar > 0x46)) {
 tempchar = 0x00;
 }
 if ((tempchar > 0x39) && (tempchar < 0x41)) {
 tempchar = 0x00;
 }
 if ((tempchar > 0x40) && (tempchar < 0x47)) {
 tempchar -= 0x37;
 }
 if ((tempchar > 0x2f) && (tempchar < 0x3a)) {
 tempchar -= 0x30;
 }
 upar[n] += tempchar;
 } while (tempchar2 != 0);
 }

 if (nparams == 0) {
 cmd = oldcmd;
 }
 return cmd;
}





void linein(char* pstring){
char inChar = 0;

 while(inChar != '\r'){


 if (UART1_Data_Ready()){
 inChar = UART1_Read();
 UART1_Write(inChar);
 if(inChar == '\r'){
 UART1_Write('\n');
 *pstring ++= '\0';
 }
 else {
 if (inChar != 0x7f ){
 *pstring++ = inChar;
 }
 if (inChar == 0x7f ){
 *--pstring = 0x00;
 }
 }
 }
 if(u2_rx_flag){
 u2_rx_flag = 0;
 if(u2_rx_data > 127){
 UART1_Write_Text("\r\n");
 UART1_Write_Text(int_rx_buf);
 }
 else{
 UART1_Write_Text("-");
 UART1_Write_Text(int_rx_buf);
 }
 }
 }
}


char chin(void){
char temp;

 while(!UART1_Data_Ready());
 temp = UART1_Read();
 return temp;
}


void chout(char outchar){

 UART1_Write(outchar);
 if(outchar == 0x0d){
 UART1_Write(0x0a);
 }
}
